<!--suerOrder 确定订单 -->
<template>
  <div class="suerOrder">

    <div class="mb10 address flex flex-m " @click="goAddress">
     <img class="icon-img" src="@/assets/img/img/site.png" alt="">
      <div class="flex-1 ml10 mr10">
        <div v-if="form.user_info.receiver">
          <div>收货人: <span class="mr20 ml10">{{form.user_info.receiver}}</span> <span class="receiver_mobile">{{form.user_info.receiver_mobile}}</span></div>
          <div class="mt10">{{form.user_info.address_text}}{{form.user_info.address}}</div>
        </div>

        <div v-else class="flex flex-m"> 添加收货地址</div>

      </div>
      <van-icon name="arrow" size="0.4rem" />
    </div>

    <van-card class="bgfff" v-for="(item,index) in form.goods" :key="index" :num="item.num" :price="item.price" :title="item.title" :thumb="item.images" >
      <div slot="bottom">
        <div>{{item.option_name | replaceStr}}</div>
      </div>
      <div slot="footer">
        共 <span class="m_color">{{item.num}}</span> {{item.unit | unit}}商品，共计<span class="red"> ¥ {{item.total  | toNum(2) }}</span>
      </div>
    </van-card>

    <div v-if="receipt_required" class="mb10 address flex flex-m " @click="goReceipt" style="margin-top: 12px;padding-right: 0px;padding-top: 0px;padding-bottom: 0px; border: 1px solid">
      <img class="icon-img" src="@/assets/img/img/site.png" alt="">
      <div class="flex-1 ml10 mr10">
        <div v-if="form.user_info.receiver">
          <div>输入收据: </div>
        </div>
      </div>
      <van-icon name="arrow" size="0.4rem" color="white" style="font-size: 0.4rem;background: #50659f;padding: 20px;" />
    </div>

    <van-cell-group class="mt10">
      <van-cell title="商品小计">
        <div class="m_black">{{form.goods_amount | toNum(2) | money}}</div>
      </van-cell>
      <van-cell title="运费">
        <div class="m_black">{{form.express_amount | toNum(2) | money}}</div>
      </van-cell>
    </van-cell-group>

    <van-submit-bar :price="form.total_amount*100" button-text="立即付款" @submit="onSubmit"> </van-submit-bar>

  </div>
</template>

<script>
export default {
  name: 'suerOrder',
  data() {
    return {
      receipt_required: false,
      form: {
        goods: [],
        user_info: {
          receiver: '', //收件人
          receiver_mobile: '', //收件人联系方式
          province: '', //省
          city: '', //市
          area: '', //区
          address_text: '',
          address: '', //详细地址
        },
        express_amount: 0, //运费	
        goods_price: 0, //产品总额
        total_amount: 0, //订单总额
        receipt: {}
      }
    }
  },
  beforeRouteEnter(to, from, next) {
    let paths = ['/index/car', '/goodsDetail']
    if (paths.includes(from.path)) {
      sessionStorage.address = ''
    }
    next()
  },

  created() {
    this.init();
    this.form.receipt = JSON.parse(sessionStorage.receipt);
  },


  methods: {
    //初始化方法
    init() {
      this.initData()
      this.initAddress()
     
    },
    initData() {
      let goodsInfo = sessionStorage.orderData && JSON.parse(sessionStorage.orderData) || {}
      this.form.goods = goodsInfo.goods
      this.form.goods_amount = goodsInfo.goods_price
      this.form.total_amount = this.form.goods_amount + this.form.express_amount

    },

    pre_count(){
     let flag = !!this.form.user_info.receiver
     if(!flag){
       return 
     }
      this.m_loading()
      this.api.pre_count(this.form).then(res=>{
        let data = res.data
        this.form.total_amount = data.total_amount
        this.form.express_amount = data.express_amount
        this.receipt_required = data.receipt_required
        this.form.receipt.receiptRequired = !this.receipt_required ? 'NoReceiptRequired' : '';
        this.m_hideLoading()

      })
    },

    initAddress() {
      let address = sessionStorage.address && JSON.parse(sessionStorage.address) || ''
      if (address) {
        this.setAddress(address)
      } else {
        this.get_default_address().then(res => {
          this.setAddress(res.data)

        })
      }
    },

    setAddress(address) {
      this.form.user_info = address
      this.form.user_info.receiver = address.name
      this.form.user_info.receiver_mobile = address.mobile
      this.pre_count()
    },

    goAddress() {
      this.$router.push('/address?choice=1')
    },

    goReceipt() {
      this.$router.push('/receipt')
    },

    onSubmit() {
      console.log('this.form)');
      console.log(this.form);
      console.log(this.form.receipt.receiptRequired);
      if(this.form.receipt.receiptRequired == '' || this.form.receipt.receiptRequired == undefined) {
        this.m_toast('receiptRequired');
      } else {
        this.m_loading()
        this.api.order_add(this.form).then(res => {
          this.m_hideLoading()
          let data = res.data
          console.log(data, 'data')
          this.$router.replace({ path: '/goodsPay', query: { order_id: data.id, order_no: data.order_no, amount: data.total_amount, type: data.type } })
        })
      }
    },

    get_default_address() {
      return this.api.default_address().then(res => {
        if (res.data.receiver) {
          sessionStorage.address = JSON.stringify(res.data)
        }
        return res
      })
    },
  },
}

</script>
<style lang='scss' scoped>
.suerOrder {
  padding-bottom: 1.4rem;
}

.address {
  padding: 0.28rem;
  box-sizing: border-box;
  background: #fff;
    color: #444;
}

.receiver_mobile{
    color: #8F8F8F;
}
.icon-img{
    width: 0.5rem;
    height: 0.5rem;
    display: block;
}
</style>